#!/usr/bin/env python
# -*- coding: utf-8 -*-
##
##    Copyright (C) 2009 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## More infos : http://www.manatlan.com/page/totem-plugin-flux
##
"""
changelog 0.2 :
 - the 2 waiting process display now a text msg
 - progress bar in plugin flux (playlists)
 - "window add/edit streams" is now localizable.
 - string "modify" -> "Edit"
 - waiting process now set_sensitive(false) plugin the plugin flux
 - menu play corrected ("widget" not defined)
 - add "podcasts audio rfi"
 - real description + version in plugin.totem-plugin
 - cursor wait centralized and try/catched (error in stdout)
 - plugin "Podcasts Video Canal" -> "Podcasts Video Canal+"

"""
import gobject
gobject.threads_init()
import pygst
pygst.require ("0.10")
import gst

import os
import totem
import gtk
import time
import thread

try:
    totem.Plugin
except:
    totem.Plugin= object


from providers import get_providers

def InputBox(parent,tuple,title=""):
    nom,url=tuple
    dialog = gtk.Dialog(title, parent, 0,
            (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OK, gtk.RESPONSE_OK))
    dialog.set_default_response(gtk.RESPONSE_OK)

    table = gtk.Table(2, 2)
    table.set_row_spacings(4)
    table.set_col_spacings(4)
    dialog.vbox.add(table)

    label = gtk.Label(_("url"))
    label.set_use_underline(True)
    table.attach(label, 0, 1, 0, 1)

    local_entry1 = gtk.Entry()
    local_entry1.set_text(url)
    #~ local_entry1.connect("activate", lambda w : dialog.response(gtk.RESPONSE_OK))
    table.attach(local_entry1, 1, 2, 0, 1)

    label.set_mnemonic_widget(local_entry1)

    label2 = gtk.Label(_("name"))
    label2.set_use_underline(True)
    table.attach(label2, 0, 1, 1, 2)

    local_entry2 = gtk.Entry()
    local_entry2.set_text(nom)
    local_entry1.connect("activate", lambda w : dialog.response(gtk.RESPONSE_OK))
    table.attach(local_entry2, 1, 2, 1, 2)
    label2.set_mnemonic_widget(local_entry2)


    dialog.show_all()

    response = dialog.run()

    ret = None
    if response == gtk.RESPONSE_OK:
        url= local_entry1.get_text().decode("utf_8").strip()
        if url:
            nom= local_entry2.get_text().decode("utf_8").strip()
            if not nom:
                nom=os.path.basename(url)
            ret=(nom,url)
    dialog.destroy()

    return ret


class Selector(gtk.ScrolledWindow):
    def __init__(self,parent,liste,callback):
        gtk.ScrolledWindow.__init__(self)
        self._parent = parent
        self.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.set_shadow_type(gtk.SHADOW_IN)
        self.callback=callback
        self.t=gtk.TreeView()
        self.t.set_headers_visible(False)
        self.t.show()

        cell_renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn("stream", cell_renderer,text=0)
        self.t.append_column(column)

        self.l=gtk.ListStore(str,object)
        self.fill(liste)
        self.t.set_model(self.l)

        self.add(self.t)
        self.t.connect("row_activated",self.select)

        #~ self.t.connect('button-press-event', self.on_selector_mouseClick)
        self.t.connect('button-release-event', self.on_selector_mouseClick)
        self.show()

    def fill(self,liste):
        self.__liste=liste
        self.l.clear()
        for nom,url in liste:
            self.l.append((nom,url))

    def select(self,widget,rows,tc,playNow=True):
        idx=rows[0]
        if hasattr(self.__liste,"get"):
            nom,url= self.__liste.get(idx)
        else:
            nom,url= self.__liste[idx]

        self._parent.waitOn(_("Loading ..."))

        gobject.idle_add( self.doIt, nom,url,playNow )

    def doIt(self, nom,url,playNow):
        if hasattr(url,"__call__"): # it's not a string/url, it's a func which return the url

            def _m(func,cb):    #~ do: url = url()
                ret=func()

                # if "ret" is a generator (plugin flux), fetch results
                # (the generator return a fraction, and at the end, the playlist (string))
                if ret.__class__.__name__=="generator":
                    for nimp in ret:
                        if type(nimp) in [int,float]:
                            self.parent.msg.set_fraction(nimp)
                    ret=nimp    # the last element is the string (playlist)

                gobject.idle_add(cb,nom,ret,playNow)

            thread.start_new_thread(_m, (url,self.endIt))
        else:
            self.endIt(nom,url,playNow)

    def endIt(self,nom,url,playNow):
        self.callback(nom,url,playNow)
        self._parent.waitOff()


    def on_selector_mouseClick(self,widget,event): #sel,item,event):
        #~ print widget.get_cursor()
        #~ print widget.get_selection().get_selected()
        if event.button==3:# and event.type == gtk.gdk.BUTTON_PRESS:
            model,iter = widget.get_selection().get_selected()

            menu = gtk.Menu()

            if iter:
                item = gtk.ImageMenuItem( _("Play") )
                item.connect("activate",self.on_menu_play,widget)
                item.show()
                menu.append(item)

                item = gtk.ImageMenuItem( _("Enqueue") )
                item.connect("activate",self.on_menu_enqueue,widget)
                item.show()
                menu.append(item)

            if hasattr(self.__liste,"save"):

                item = gtk.ImageMenuItem( _("Add") )
                item.connect("activate",self.on_menu_add,widget)
                item.show()
                menu.append(item)
                if iter:
                    item = gtk.ImageMenuItem( _("Edit") )
                    item.connect("activate",self.on_menu_mod,widget)
                    item.show()
                    menu.append(item)
                    item = gtk.ImageMenuItem( _("Remove") )
                    item.connect("activate",self.on_menu_del,widget)
                    item.show()
                    menu.append(item)

            if len(menu)>0:
                menu.popup(None,None,None,event.button,event.time)

    def on_menu_play(self,m,w):
        model,iter = w.get_selection().get_selected()
        idx=model.get_path(iter)[0]
        self.select(self.t,[idx,],None,True)

    def on_menu_enqueue(self,m,w):
        model,iter = w.get_selection().get_selected()
        idx=model.get_path(iter)[0]
        self.select(self.t,[idx,],None,False)

    def on_menu_del(self,m,widget):
        model,iter = widget.get_selection().get_selected()
        idx=model.get_path(iter)[0]
        del self.__liste[idx]
        self.__liste.save()
        self.fill(self.__liste)

    def on_menu_mod(self,m,widget):
        model,iter = widget.get_selection().get_selected()
        idx=model.get_path(iter)[0]
        nom,url=self.__liste[idx]
        r=InputBox(None,(nom,url),_("Edit"))
        if r:
            self.__liste[idx]=r
            self.__liste.save()
            self.fill(self.__liste)

    def on_menu_add(self,*a):
        r=InputBox(None,("",""),_("Add"))
        if r:
            nom,url=r
            self.__liste.append((nom,url))
            self.__liste.save()
            self.fill(self.__liste)

class MSelector(gtk.VBox):
    def __init__(self,providers,callback_play):
        gtk.VBox.__init__(self)

        self.providers=providers

        l=gtk.ListStore(str,)
        for nom,provider in providers:
            l.append((nom,))
        c=gtk.ComboBox(l)
        cell = gtk.CellRendererText()
        c.pack_start(cell, True)
        c.add_attribute(cell, 'text', 0)
        c.connect('changed', self.on_change)
        c.show()

        self.pack_start(c,False,False)

        self.selector = Selector(self,[],callback_play)
        self.add(self.selector)
        self.show()

        self.msg=gtk.ProgressBar()
        self.pack_end(self.msg,False)
        self.msg.hide()


    def on_change(self,w):
        idx=w.get_active()
        nom,func = self.providers[idx]

        self.waitOn(_("Loading ..."))

        gobject.idle_add( self.doIt, func )

    def doIt(self,func):
        def _m(func,cb):
            ret=func()
            gobject.idle_add(cb,ret)

        thread.start_new_thread(_m, (func,self.endIt))

    def endIt(self,ll):
        self.selector.fill( ll )
        self.waitOff()
        return False

    def waitOn(self,m=""):
        self.msg.set_text(m)
        self.msg.set_fraction(0)
        self.msg.show()
        self.set_sensitive(False)
        try:
            self.get_parent_window().set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))
        except Exception,e:
            print "***plugin flux error***",e

    def waitOff(self):
        self.msg.hide()
        self.set_sensitive(True)
        try:
            self.get_parent_window().set_cursor(None)
        except Exception,e:
            print "***plugin flux error***",e


class PluginFlux(totem.Plugin):
    def __init__ (self):
        totem.Plugin.__init__ (self)

    def activate (self, totem_object):
        self.totem = totem_object

        #~ print dir(totem_object)
        totem_object.add_sidebar_page ("mypage1", _("Flux"),
                                MSelector(get_providers(),self.play))

    def deactivate (self, totem_object):
        totem_object.remove_sidebar_page ("mypage1")

    def play (self, nom,url,playNow):
        gst.log('play:%s:%s' %(nom,url))
        if playNow:
            #~ self.totem.add_to_playlist_and_play(url,nom,2)
            #~ self.totem.action_set_mrl_and_play(url, nom)
            #~ self.totem.action_remote(totem.REMOTE_COMMAND_ENQUEUE, url)
            self.totem.action_remote(totem.REMOTE_COMMAND_REPLACE, url)
        else:
            self.totem.action_remote(totem.REMOTE_COMMAND_ENQUEUE, url)


if __name__ == "__main__":
    _ = lambda x:x
    class Test(gtk.Window):
        def __init__(self):
            gtk.Window.__init__(self,gtk.WINDOW_TOPLEVEL)
            self.connect('delete-event', self.on_win_delete_event)
            self.resize( 300,400 )

            self.add(MSelector(get_providers(), self.play))
            self.show()

        def play(self,nom,url,playNow):
            print playNow,(nom,url)

        def loop(self):
            self.__inLoop=gobject.MainLoop()
            self.__inLoop.run()

        def on_win_delete_event(self,*args):
            self.destroy()
            gobject.MainLoop.quit(self.__inLoop)    # quit the loop

    Test().loop()
