#!/usr/bin/env python
# -*- coding: utf-8 -*-
##
##    Copyright (C) 2009 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## More infos : http://www.manatlan.com/page/totem-plugin-flux
##

try:
    from libs.date import str2date,tz2date
except:
    from date import str2date,tz2date

from xml.etree.ElementTree import fromstring,parse



def xml2vids(buf):
    """ transforme un flux rss/atom en liste de videos [(titre,url),...]"""
    try:
        xml=fromstring(buf)
        l=[]

        # traite un RSS
        #=============================================
        for i in xml[0].findall("item"):
            titre=i.findall("title")[0].text
            link=i.findall("link")[0].text
            sd=i.findall("pubDate")[0].text

            # privilegie les <enclosure url=""> sur les <link>
            enclosure=i.findall("enclosure")
            if enclosure:
                link = enclosure[0].get("url")

            # privilegie les <media:content url=""> sur les <link>
            contents=i.findall("{http://search.yahoo.com/mrss/}group/{http://search.yahoo.com/mrss/}content")
            if contents:
                link = contents[0].get("url")

            date=str2date( sd )
            date = date and date.strftime("%Y-%m-%d") or sd

            l.append(("%s (%s)"%(titre,date),link))


        # traite un ATOM
        #=============================================
        for i in xml.findall("{http://www.w3.org/2005/Atom}entry"):
            titre=i.findall("{http://www.w3.org/2005/Atom}title")[0].text
            link=i.findall("{http://www.w3.org/2005/Atom}link")[0].get("href")
            sd=i.findall("{http://www.w3.org/2005/Atom}published")[0].text

            date=tz2date( sd )
            date = date and date.strftime("%Y-%m-%d") or sd
            l.append(("%s (%s)"%(titre,date),link))

        return l
    except Exception,m:
        print "Erreur flux",m
        return []


if __name__=="__main__":
    from web import getFilePage

    cache=60*60

    aff=lambda url: xml2vids(file(getFilePage(url,cache)).read())

    print aff("http://www.dailymotion.com/rss/playlist/xo10o_franceinter_humour")
    print aff("http://www.rss-one.com/rss-6690-Sav-des-Emissions")
    print aff("http://feeds.feedburner.com/Koreus-podcasts-video")
    print aff("http://gdata.youtube.com/feeds/base/standardfeeds/top_favorites?client=ytapi-youtube-index&time=today&v=2") #ATOM
    print aff("http://gdata.youtube.com/feeds/base/users/jonathanlambertfr/uploads?alt=rss&v=2&orderby=published&client=ytapi-youtube-profile")    # RSS
    assert aff("http://leweb2zero.tv/rss")==[]    # RSS
