#!/usr/bin/env python
# -*- coding: utf-8 -*-
##
##    Copyright (C) 2009 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## More infos : http://www.manatlan.com/page/totem-plugin-flux
##

from xml.etree.ElementTree import fromstring,parse
from libs.web import getFilePage
from libs.rss import mkRssFile
import urllib

CACHE=60*60 # seconds


def getStreams(mot):
    file=getFilePage("http://www.canalplus.fr/rest/bootstrap.php?/bigplayer/search/"+mot,cache=CACHE)
    x=parse(file)
    l=[]
    for i in x.findall("VIDEO"):
        d=i.findall("INFOS/TITRAGE")
        u=i.findall("MEDIA/VIDEOS/BAS_DEBIT")
        if d:
            titre,date=d[0][0].text,d[0][1].text
            if u:
                url = u[0].text
                url=url.replace("rtmp://vod-fms.canalplus.fr/ondemand/videos/","http://vod-flash.canalplus.fr/WWWPLUS/STREAMING/")

                l.append((u"%s (%s)" %(titre,date),url))
            else:
                print "*** no url for",(titre,date)
    return l


def _getEmi(a,b):
    l=getStreams(a)
    ll=[]
    for n,u in l:
        if b in u:
            ll.append((n,u))

    return mkRssFile(a,ll)


def getGroLand():
    return _getEmi("magzine","GROLAND_EMISSION")

def getSAV():
    return _getEmi("SAV des emissions","SAV_EMISSION")

def getGui():
    return _getEmi("guignols","LES_GUIGNOLS_QUOTIDIEN")

def getPepites():
    return _getEmi("pepites","PEPITES_SUR_LE_NET_EMISSION")

def getZapping():
    return _getEmi("zapping","ZAPPING_EMISSION")



class FetchCanal():
    name="Podcasts Video Canal+"

    @staticmethod
    def get():
        return [

            ("Le zapping",getZapping),
            ("Groland",getGroLand),
            ("SAV des emission",getSAV),
            ("Les Guignols de l'info",getGui),
            ("Les pepites du net",getPepites),

        ]

if __name__ == "__main__":
    print getZapping()
    print getGroLand()
    print getSAV()
    print getGui()
    print getPepites()

    for i in FetchCanal.get():
        print i
